//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <memory>

#include "CheckMessageBox.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
using namespace OV;
//---------------------------------------------------------------------------
TModalResult PACKAGE OV::OVCheckMesBox(
   AnsiString Message,
   AnsiString Caption,
   TMsgDlgType DlgType,
   TMsgDlgButtons Buttons,
   AnsiString CheckBoxCaption,
   bool & Checked
)
{
   std::auto_ptr<TForm> Dialog(CreateMessageDialog(Message, DlgType, Buttons));
   if (!Caption.IsEmpty()) Dialog->Caption = Caption;

   TCheckBox * CheckBox = new TCheckBox(Dialog.get());
   CheckBox->Parent = Dialog.get();
   CheckBox->Caption = CheckBoxCaption;
   CheckBox->Checked = Checked;

   int Down = CheckBox->Height * 2;
   Dialog->Height += Down;
   int Top;
   for (int i = 0; i < Dialog->ControlCount; ++i) {
      TButton * Button = dynamic_cast<TButton *>(Dialog->Controls[i]);
      if (Button) {
         Top = Button->Top;
         Button->Top = Top + Down;
      }
   }
   CheckBox->Top = Top;
   CheckBox->Width = Dialog->Canvas->TextWidth(CheckBox->Caption) + 24;
   CheckBox->Left = (Dialog->Width - CheckBox->Width) / 2;

   TModalResult Result = Dialog->ShowModal();
   Checked = CheckBox->Checked;
   return Result;
}
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//
static inline void ValidCtrCheck(TOVCheckMessageBox *)
{
   new TOVCheckMessageBox(NULL);
}
//---------------------------------------------------------------------------
__fastcall TOVCheckMessageBox::TOVCheckMessageBox(TComponent * Owner)
   : TComponent(Owner)
{
   FOldModalResult = mrNone;
   FButtons << mbYes << mbNo;
   FCheckBoxCaption = "don't ask more";
   FChecked = false;
   FMessage = new TStringList;
}
//---------------------------------------------------------------------------
__fastcall TOVCheckMessageBox::~TOVCheckMessageBox()
{
   delete FMessage;
}
//---------------------------------------------------------------------------
TStrings * __fastcall TOVCheckMessageBox::GetMessage()
{
   return FMessage;
}
//---------------------------------------------------------------------------
void __fastcall TOVCheckMessageBox::SetMessage(TStrings * Value)
{
   FMessage->Assign(Value);
}
//---------------------------------------------------------------------------
void __fastcall TOVCheckMessageBox::SetButtons(TMsgDlgButtons Value)
{
   if (FButtons != Value) {
      FButtons = Value;
      FOldModalResult = mrNone;
      FChecked = false;
   }
}
//---------------------------------------------------------------------------
TModalResult __fastcall TOVCheckMessageBox::Execute()
{
   if (!FChecked || FOldModalResult == mrNone)
      FOldModalResult = OVCheckMesBox(FMessage->Text, FCaption, FDlgType, FButtons,
                                      FCheckBoxCaption, FChecked);
   return FOldModalResult;
}
//---------------------------------------------------------------------------
namespace Checkmessagebox
{
   void __fastcall PACKAGE Register()
   {
      TComponentClass classes[1] = {__classid(TOVCheckMessageBox)};
      RegisterComponents("OV", classes, 0);
   }
}
//---------------------------------------------------------------------------

